/*
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

define([
    "dojo/_base/lang",
    "./../widgets/base/Gauge",
    "./../widgets/base/Output"
], function (
    lang,
    Gauge,
    Output
) {
    var zeroUsageTemplate = _("${limit} available");

    function getResourceOutput(options) {
        if ((+options.limit) === 0) {
            return new Output(lang.mixin(options, {
                content: options.noneLegend || _("None"),
                usage: +options.usage,
                limit: +options.limit
            }));
        }
        if ((+options.limit) <= 0) {
            return new Output(lang.mixin(options, {
                content: options.unlimitedLegend || "${usage}",
                usage: +options.usage,
                limit: +options.limit
            }));
        }
        if ((+options.usage) === 0) {
            return new Output(lang.mixin(options, {
                content: options.zeroUsageLegend || zeroUsageTemplate,
                usage: +options.usage,
                limit: +options.limit
            }));
        }

        return new Gauge(lang.mixin(options, {
            legend: options.limitedLegend || "${usage}/${limit}",
            minimum: 0,
            maximum: +options.limit,
            value: +options.usage,
            usage: +options.usage,
            limit: +options.limit
        }));
    }

    return getResourceOutput;
});

