/*
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

define([], function () {

    var VIEWS = {
        ACCOUNT:"subscription-account",
        TEMPLATE:"subscription-template",
        PARAMETERS:"subscription-parameters"
    };

    var wizardSteps = [
        {viewId: VIEWS.ACCOUNT,    text: _("Select {0} Account").replace("{0}", "<br/>"), active: true },
        {viewId: VIEWS.TEMPLATE,   text: _("Select {0} Service Template").replace("{0}", "<br/>"), active: false},
        {viewId: VIEWS.PARAMETERS, text: _("Set {0} Parameters").replace("{0}", "<br/>"), active: false}
    ];

    return {

        VIEWS: VIEWS,

        getWizardControlView: function(activeView) {
            if (activeView !== undefined) {
                for (var i = 0; i < wizardSteps.length; ++i){
                    if (wizardSteps[i].viewId === activeView) {
                        wizardSteps[i].active = true;
                        wizardSteps[0].active = false;
                        break;
                    }
                }
            }

            return ["aps/WizardControl",{
                steps: wizardSteps
            }];
        }
    };
});
