<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

interface Model_OSA_AccountAttributesManagerInterface
{
    const ATTRIBUTE_ACRONIS_ACCOUNT_NUMBER = 'AAN';
    const ATTRIBUTE_MINIMAL_COMMITMENT_TIER = 'MinComTier';
    const ATTRIBUTE_MINIMAL_COMMITMENT_VALUE = 'MinCom';
    const ATTRIBUTE_MINIMAL_COMMITMENT_MONTH = 'MinComMonth';
    const ATTRIBUTE_ENABLE_AUTO_SWITCH = 'EnableAutoSwitch';

    const MINIMAL_COMMITMENT_MONTH_FORMAT = 'm-Y';

    /**
     * @param int $accountNumber
     * @return int[]
     */
    public function getAccountsWithAttributeAAN($accountNumber);

    /**
     * @param $accountId
     * @return null|string
     */
    public function getAttributeAAN($accountId);

    /**
     * @param int $accountId
     * @return string
     * @throws Exception
     */
    public function getAttributeMinimalCommitmentTier($accountId);

    /**
     * @param int $accountId
     * @param int $value
     * @return Service_PbaApi_Api_Response_UpdateObjAttrList
     */
    public function setAttributeMinimalCommitmentTier($accountId, $value);

    /**
     * @param int $accountId
     * @return string
     * @throws Exception
     */
    public function getAttributeMinimalCommitmentValue($accountId);

    /**
     * @param int $accountId
     * @param int $value
     * @return Service_PbaApi_Api_Response_UpdateObjAttrList
     */
    public function setAttributeMinimalCommitmentValue($accountId, $value);

    /**
     * @param int $accountId
     * @return string
     * @throws Exception
     */
    public function getAttributeMinimalCommitmentMonth($accountId);

    /**
     * @param int $accountId
     * @param int $value
     * @return Service_PbaApi_Api_Response_UpdateObjAttrList
     */
    public function setAttributeMinimalCommitmentMonth($accountId, $value);

    /**
     * @param int $accountId
     * @return string
     * @throws Exception
     */
    public function getAttributeEnableAutoSwitch($accountId);

    /**
     * @param int $accountId
     * @param int $value
     * @return Service_PbaApi_Api_Response_UpdateObjAttrList
     */
    public function setAttributeEnableAutoSwitch($accountId, $value);
}