<?php
/**
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

use Acronis\App\CloudApi\ApiInterface;
use Acronis\Cloud\Client\Model\Common\Types\Role;
use Acronis\Cloud\Client\Model\Common\Types\UserNotification;

class Model_PropertyConverters_ServiceRolesConverter
{
    /** @noinspection PhpDocMissingThrowsInspection */
    /**
     * @param $userResource $user
     * @return string[]
     */
    public static function getRoles($userResource)
    {
        $hasBackupPrivileges = Arr::get($userResource, 'privileged', 0);
        $tenantType = Arr::getNestedItem($userResource, ['tenant', 'type'], tenant::TYPE_CUSTOMER);

        if ($hasBackupPrivileges === users::ADMINISTRATOR_PRIVILEGES_NO) {
            return [Role::BACKUP_USER];
        } else if ($tenantType == tenant::TYPE_CUSTOMER) {
            return [Role::BACKUP_USER, Role::COMPANY_ADMIN];
        }

        return [Role::PARTNER_ADMIN];
    }
}