<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

/**
 * @link https://doc.apsstandard.org/2.2/spec/ui/integration-ccp/notifications/
 */
interface Model_ScreenNotification_Struct_MessageInterface
{
    /**
     * @param string $accountId
     */
    public function setAccountId($accountId);


    /**
     * @return string
     */
    public function getAccountId();


    /**
     * @param string $context
     */
    public function setContext($context);


    /**
     * @return string
     */
    public function getContext();


    /**
     * @param string $created
     */
    public function setCreated($created);


    /**
     * @return string
     */
    public function getCreated();


    /**
     * @param Model_ScreenNotification_Struct_LocalizedMessageInterface $details
     */
    public function setDetails(Model_ScreenNotification_Struct_LocalizedMessageInterface $details = null);


    /**
     * @return Model_ScreenNotification_Struct_LocalizedMessageInterface
     */
    public function getDetails();


    /**
     * @param Model_ScreenNotification_Struct_LocalizedMessageInterface $fullDetails
     */
    public function setFullDetails(Model_ScreenNotification_Struct_LocalizedMessageInterface $fullDetails = null);


    /**
     * @return Model_ScreenNotification_Struct_LocalizedMessageInterface
     */
    public function getFullDetails();


    /**
     * @param string $id
     */
    public function setId($id);


    /**
     * @return string
     */
    public function getId();


    /**
     * @param string $link
     */
    public function setLink($link);


    /**
     * @return string
     */
    public function getLink();


    /**
     * @param string $linkMore
     */
    public function setLinkMore($linkMore);


    /**
     * @return string
     */
    public function getLinkMore();


    /**
     * @param Model_ScreenNotification_Struct_LocalizedMessageInterface $linkMoreText
     */
    public function setLinkMoreText(Model_ScreenNotification_Struct_LocalizedMessageInterface $linkMoreText = null);


    /**
     * @return Model_ScreenNotification_Struct_LocalizedMessageInterface
     */
    public function getLinkMoreText();


    /**
     * @param Model_ScreenNotification_Struct_LocalizedMessageInterface $message
     */
    public function setMessage(Model_ScreenNotification_Struct_LocalizedMessageInterface $message = null);


    /**
     * @return Model_ScreenNotification_Struct_LocalizedMessageInterface
     */
    public function getMessage();


    /**
     * @param string $modified
     */
    public function setModified($modified);


    /**
     * @return string
     */
    public function getModified();


    /**
     * @param string $packageId
     */
    public function setPackageId($packageId);


    /**
     * @return string
     */
    public function getPackageId();


    /**
     * @param boolean $resolved
     */
    public function setResolved($resolved);


    /**
     * @return boolean
     */
    public function getResolved();


    /**
     * @param string $status
     */
    public function setStatus($status);


    /**
     * @return string
     */
    public function getStatus();


    /**
     * @param string $type
     */
    public function setType($type);


    /**
     * @return string
     */
    public function getType();


    /**
     * @param boolean $updated
     */
    public function setUpdated($updated);


    /**
     * @return boolean
     */
    public function getUpdated();

    /**
     * @param string $userId
     */
    public function setUserId($userId);


    /**
     * @return string
     */
    public function getUserId();



    /**
     * @return string
     */
    public function getInitiatorId();

    /**
     * @param string $initiatorId
     */
    public function setInitiatorId($initiatorId);

    /**
     * @return string
     */
    public function getInitiator();

    /**
     * @param string $initiator
     */
    public function setInitiator($initiator);

    /**
     * @return string
     */
    public function getService();

    /**
     * @param string $service
     */
    public function setService($service);

    /**
     * @return string
     */
    public function getRequired();

    /**
     * @param string $required
     */
    public function setRequired($required);

    /**
     * @return string
     */
    public function getParentId();

    /**
     * @param string $parentId
     */
    public function setParentId($parentId);

    /**
     * @return string
     */
    public function getIpAddress();

    /**
     * @param string $ipAddress
     */
    public function setIpAddress($ipAddress);
}