<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_GetAdministratorById extends Service_BaseClient_Request_Base
{
    const REQUEST_URL_FORMAT = '/admins/%s';
    const HTTP_CODE_NOT_FOUND = 404;

    /** @var int */
    private $_adminId;

    /**
     * @param int $adminId
     */
    public function __construct($adminId)
    {
        $this->_adminId = $adminId;
        $this->_resource = sprintf(self::REQUEST_URL_FORMAT, $adminId);
        $this->_method = self::METHOD_GET;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_MspApiClient_Response_GetAdministratorById
     * @throws Exception
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        return new Service_MspApiClient_Response_GetAdministratorById($responseBody);
    }
}
