<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Request_GetGroups extends Service_BaseClient_Request_Base
{
    const REQUEST_URL_FORMAT_FROM_UUIDS = '/groups/%s/children?request_type=tenants_batch&uuids=%s';

    /**
     * @param int $parentGroupId
     */
    public function __construct($parentGroupId, array $uuids)
    {
        $this->_resource = sprintf(self::REQUEST_URL_FORMAT_FROM_UUIDS, $parentGroupId, urlencode(implode(',', $uuids)));
        $this->_method = self::METHOD_GET;
    }

    /**
     * @param string $httpCode
     * @param string $responseBody
     * @return Service_MspApiClient_Response_GetUsers
     */
    public function getExpectedResponse($httpCode = NULL, $responseBody = NULL)
    {
        return new Service_MspApiClient_Response_GetGroups($responseBody);
    }
}
