<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Response_Accounts extends Service_BaseClient_Response_Base
{
    const PROPERTY_ID = 'id';
    const PROPERTY_LOGIN = 'login';
    const PROPERTY_SERVER_URL = 'server_url';

    /** @var Service_MspApiClient_Response_Struct_FactoryInterface */
    private $_factory;

    /**
     * @param string|null $responseBody
     * @param Service_MspApiClient_Response_Struct_FactoryInterface $factory
     */
    public function __construct($responseBody = NULL, Service_MspApiClient_Response_Struct_FactoryInterface $factory = NULL)
    {
        $this->_factory = is_null($factory) ? new Service_MspApiClient_Response_Struct_Factory() : $factory;
        parent::__construct($responseBody);
    }

    /**
     * @param array $responseData
     * @return Service_MspApiClient_Response_Struct_Account
     */
    protected function _init(array $responseData)
    {
        $accountInfo = $this->_factory->getAccount();
        $accountInfo->setId($responseData[self::PROPERTY_ID]);
        $accountInfo->setLogin($responseData[self::PROPERTY_LOGIN]);
        $accountInfo->setServerUrl($responseData[self::PROPERTY_SERVER_URL]);
        return $accountInfo;
    }
}
