<?php
/**
 * @Copyright © 2002-2019 Acronis International GmbH. All rights reserved
 */

class Service_MspApiClient_Response_GetGroupById extends Service_BaseClient_Response_Base
{
    const PROPERTY_ID = 'id';
    const PROPERTY_UUID = 'uuid';
    const PROPERTY_CREATION_DATE = 'creation_date';
    const PROPERTY_NAME = 'name';
    const PROPERTY_CUSTOMER_ID = 'customer_id';
    const PROPERTY_PRIVILEGES = 'privileges';
    const PROPERTY_VM_COUNT = 'vm_count';
    const PROPERTY_SERVER_COUNT = 'server_count';
    const PROPERTY_WORKSTATION_COUNT = 'workstation_count';
    const PROPERTY_MOBILE_COUNT = 'mobile_count';
    const PROPERTY_MAILBOX_COUNT = 'mailbox_count';



















































































































// scripts_app_service_msp_api_client_response_get_group_by_id_constant this code is used for code generation, do not remove!
    const PROPERTY_WEB_HOSTING_SERVER_COUNT = 'web_hosting_server_count';
    const PROPERTY_WEBSITE_COUNT = 'website_count';
    const PROPERTY_STORAGE_SIZE = 'storage_size';
    const PROPERTY_LOCAL_STORAGE_SIZE = 'local_storage_size';
    const PROPERTY_USAGE = 'usage';
    const PROPERTY_CONTACT = 'contact';
    const PROPERTY_BRAND = 'brand';
    const PROPERTY_VERSION = 'version';
    const PROPERTY_STATUS = 'status';
    const PROPERTY_KIND = 'kind';
    const PROPERTY_PARENT_ID = 'parent_id';



















































































































// scripts_app_service_msp_api_client_response_get_group_by_id_constant_size_for this code is used for code generation, do not remove!
    const PROPERTY_SIZE_FOR_WEB_HOSTING_SERVERS = 'size_for_web_hosting_servers';
    const PROPERTY_SIZE_FOR_WEBSITES = 'size_for_websites';
    const PROPERTY_SIZE_FOR_MOBILES = 'size_for_mobiles';
    const PROPERTY_SIZE_FOR_SERVERS = 'size_for_servers';
    const PROPERTY_SIZE_FOR_VMS = 'size_for_vms';
    const PROPERTY_SIZE_FOR_WORKSTATIONS = 'size_for_workstations';
    const PROPERTY_SIZE_FOR_MAILBOX = 'size_for_mailboxes';
    const PROPERTY_INTERNAL_TAG = 'internal_tag';
    const PROPERTY_STORAGE = 'storage';
    const PROPERTY_PRICING = 'pricing';
    const PROPERTY_PRICING_MODE = 'mode';

    const PROPERTY_CONTACT_EMAIL = 'email';
    const PROPERTY_CONTACT_CITY = 'city';
    const PROPERTY_CONTACT_FIRSTNAME = 'firstname';
    const PROPERTY_CONTACT_LASTNAME = 'lastname';
    const PROPERTY_CONTACT_ZIPCODE = 'zipcode';
    const PROPERTY_CONTACT_PHONE = 'phone';
    const PROPERTY_CONTACT_COUNTRY = 'country';
    const PROPERTY_CONTACT_STATE = 'state';
    const PROPERTY_CONTACT_ADDRESS1 = 'address1';
    const PROPERTY_CONTACT_ADDRESS2 = 'address2';

    /** @var Service_MspApiClient_Response_Struct_FactoryInterface */
    private $_factory;

    /**
     * @param string|null $responseBody
     * @param Service_MspApiClient_Response_Struct_FactoryInterface $factory
     */
    public function __construct($responseBody = NULL, Service_MspApiClient_Response_Struct_FactoryInterface $factory = NULL)
    {
        $this->_factory = is_null($factory) ? new Service_MspApiClient_Response_Struct_Factory() : $factory;
        parent::__construct($responseBody);
    }

    /**
     * @param array $responseData
     * @return Service_MspApiClient_Response_Struct_GroupInfo
     * @throws \Exception
     */
    protected function _init(array $responseData)
    {
        $groupInfo = $this->_factory->getGroupInfo();

        $groupInfo->setUuid($this->_getProperty(static::PROPERTY_UUID, $responseData));
        $groupInfo->setCreationDate($this->_getProperty(static::PROPERTY_CREATION_DATE, $responseData));
        $groupInfo->setId($this->_getProperty(static::PROPERTY_ID, $responseData));
        $groupInfo->setName($this->_getProperty(static::PROPERTY_NAME, $responseData));
        $groupInfo->setCustomerId($this->_getProperty(static::PROPERTY_CUSTOMER_ID, $responseData));
        $groupInfo->setVersion($this->_getProperty(static::PROPERTY_VERSION, $responseData));
        $groupInfo->setKind($this->_getProperty(static::PROPERTY_KIND, $responseData));
        $groupInfo->setStatus($this->_getProperty(static::PROPERTY_STATUS, $responseData));
        $groupInfo->setParentId($this->_getProperty(static::PROPERTY_PARENT_ID, $responseData));
        $groupInfo->setInternalTag($this->_getProperty(static::PROPERTY_INTERNAL_TAG, $responseData));

        $privilegesData = $this->_getProperty(static::PROPERTY_PRIVILEGES, $responseData);
        $privileges = $groupInfo->getPrivileges();
        $privileges->setVmCount($this->_getProperty(static::PROPERTY_VM_COUNT, $privilegesData));
        $privileges->setServerCount($this->_getProperty(static::PROPERTY_SERVER_COUNT, $privilegesData));
        $privileges->setWorkstationCount($this->_getProperty(static::PROPERTY_WORKSTATION_COUNT, $privilegesData));
        $privileges->setMobileCount($this->_getProperty(static::PROPERTY_MOBILE_COUNT, $privilegesData, false));
        $privileges->setMailboxCount($this->_getProperty(static::PROPERTY_MAILBOX_COUNT, $privilegesData, false));



















































































































// scripts_app_service_msp_api_client_response_get_group_by_id_set_privileges this code is used for code generation, do not remove!
        $privileges->setWebHostingServerCount($this->_getProperty(static::PROPERTY_WEB_HOSTING_SERVER_COUNT, $privilegesData, false));
        $privileges->setWebsiteCount($this->_getProperty(static::PROPERTY_WEBSITE_COUNT, $privilegesData, false));
        $privileges->setStorageSize($this->_getProperty(static::PROPERTY_STORAGE_SIZE, $privilegesData));
        $privileges->setLocalStorageSize($this->_getProperty(static::PROPERTY_LOCAL_STORAGE_SIZE, $privilegesData, false));

        $usageData = $this->_getProperty(static::PROPERTY_USAGE, $responseData);
        $usage = $groupInfo->getUsage();
        $usage->setVmCount($this->_getProperty(static::PROPERTY_VM_COUNT, $usageData));
        $usage->setServerCount($this->_getProperty(static::PROPERTY_SERVER_COUNT, $usageData));
        $usage->setWorkstationCount($this->_getProperty(static::PROPERTY_WORKSTATION_COUNT, $usageData));
        $usage->setMobileCount($this->_getProperty(static::PROPERTY_MOBILE_COUNT, $usageData, false));
        $usage->setMailboxCount($this->_getProperty(static::PROPERTY_MAILBOX_COUNT, $usageData, false));



















































































































// scripts_app_service_msp_api_client_response_get_group_by_id_set_usage this code is used for code generation, do not remove!
        $usage->setWebHostingServerCount($this->_getProperty(static::PROPERTY_WEB_HOSTING_SERVER_COUNT, $usageData, false));
        $usage->setWebsiteCount($this->_getProperty(static::PROPERTY_WEBSITE_COUNT, $usageData, false));
        $usage->setStorageSize($this->_getProperty(static::PROPERTY_STORAGE_SIZE, $usageData));
        $usage->setLocalStorageSize($this->_getProperty(static::PROPERTY_LOCAL_STORAGE_SIZE, $usageData, false));

        $usage->setSizeForVms($this->_getProperty(static::PROPERTY_SIZE_FOR_VMS, $usageData, false));
        $usage->setSizeForMobiles($this->_getProperty(static::PROPERTY_SIZE_FOR_MOBILES, $usageData, false));
        $usage->setSizeForServers($this->_getProperty(static::PROPERTY_SIZE_FOR_SERVERS, $usageData, false));
        $usage->setSizeForWorkstations($this->_getProperty(static::PROPERTY_SIZE_FOR_WORKSTATIONS, $usageData, false));
        $usage->setSizeForMailbox($this->_getProperty(static::PROPERTY_SIZE_FOR_MAILBOX, $usageData, false));



















































































































// scripts_app_service_msp_api_client_response_get_group_by_id_set_size this code is used for code generation, do not remove!
        $usage->setSizeForWebHostingServers($this->_getProperty(static::PROPERTY_SIZE_FOR_WEB_HOSTING_SERVERS, $usageData, false));
        $usage->setSizeForWebsite($this->_getProperty(static::PROPERTY_SIZE_FOR_WEBSITES, $usageData, false));

        $contactData = $this->_getProperty(static::PROPERTY_CONTACT, $responseData);
        $contact = $groupInfo->getContact();
        $contact->setEmail($this->_getProperty(static::PROPERTY_CONTACT_EMAIL, $contactData));
        $contact->setCity($this->_getProperty(static::PROPERTY_CONTACT_CITY, $contactData, false));
        $contact->setCountry($this->_getProperty(static::PROPERTY_CONTACT_COUNTRY, $contactData, false));
        $contact->setFirstname($this->_getProperty(static::PROPERTY_CONTACT_FIRSTNAME, $contactData, false));
        $contact->setLastname($this->_getProperty(static::PROPERTY_CONTACT_LASTNAME, $contactData, false));
        $contact->setPhone($this->_getProperty(static::PROPERTY_CONTACT_PHONE, $contactData, false));
        $contact->setZipcode($this->_getProperty(static::PROPERTY_CONTACT_ZIPCODE, $contactData, false));
        $contact->setAddress1($this->_getProperty(static::PROPERTY_CONTACT_ADDRESS1, $contactData, false));
        $contact->setAddress2($this->_getProperty(static::PROPERTY_CONTACT_ADDRESS2, $contactData, false));

        $storageData = $this->_getProperty(static::PROPERTY_STORAGE, $responseData);
        $storage = $groupInfo->getStorage();
        $storage->setUuid($this->_getProperty(static::PROPERTY_UUID, $storageData));
        $storage->setName($this->_getProperty(static::PROPERTY_NAME, $storageData));
        $storage->setId($this->_getProperty(static::PROPERTY_ID, $storageData));

        $pricingData = $this->_getProperty(static::PROPERTY_PRICING, $responseData);
        $pricing = $groupInfo->getPricing();
        $pricing->setMode($this->_getProperty(static::PROPERTY_PRICING_MODE, $pricingData));

        return $groupInfo;
    }
}





