<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_OpenApi_Validator_Factory
{
    /**
     * @param Service_OpenApi_Validator_ItemInterface $successor
     * @return Service_OpenApi_Validator_InvalidCode
     */
    public function getInvalidCode(Service_OpenApi_Validator_ItemInterface $successor = NULL)
    {
        return new Service_OpenApi_Validator_InvalidCode($successor);
    }

    /**
     * @param Service_OpenApi_Validator_ItemInterface $successor
     * @return Service_OpenApi_Validator_EmptyResponse
     */
    public function getEmptyResponse(Service_OpenApi_Validator_ItemInterface $successor = NULL)
    {
        return new Service_OpenApi_Validator_EmptyResponse($successor);
    }

    /**
     * @param Service_OpenApi_Validator_ItemInterface $successor
     * @return Service_OpenApi_Validator_XmlFailure
     */
    public function getXmlFailure(Service_OpenApi_Validator_ItemInterface $successor = NULL)
    {
        return new Service_OpenApi_Validator_XmlFailure($successor);
    }

    /**
     * @param Service_OpenApi_Validator_ItemInterface $successor
     * @return Service_OpenApi_Validator_InvalidStatus
     */
    public function getInvalidStatus(Service_OpenApi_Validator_ItemInterface $successor = NULL)
    {
        return new Service_OpenApi_Validator_InvalidStatus($successor);
    }
} 
