<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Request_GetObjectAttributesList extends Service_PbaApi_Client_Request
{
    const METHOD = 'GetObjAttrList_API';

    const OBJECT_TYPE_ACCOUNTS = 0;
    const OBJECT_TYPE_USERS = 1;
    const OBJECT_TYPE_ORDERS = 2;

    /**
     * @param int $objectType
     * @param int $objectId
     */
    public function __construct($objectType, $objectId)
    {
        parent::__construct(self::METHOD, array(
            (int) $objectType,
            (int) $objectId,
            1, // Int SortNo - any integer. The parameter is required, but not used.
        ));
    }

    /**
     * @param array $responseArray
     * @return Service_PbaApi_Client_ResponseInterface
     */
    public function getExpectedResponse(array $responseArray = NULL)
    {
        return new Service_PbaApi_Api_Response_GetObjectAttributesList($responseArray);
    }
}
