<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_GetAccount extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result for operation AccountGet';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $data = $this->_getProperty(0, $responseArray);

        $account = new Service_PbaApi_Api_Response_Struct_Account();
        $account->setIntAccountAccountID($this->_getProperty(0, $data));
        $account->setLoginLink($this->_getProperty(1, $data));
        $account->setLoginLinkCurrLang($this->_getProperty(2, $data));
        $account->setVendorAccountID($this->_getProperty(3, $data));
        $account->setType($this->_getProperty(4, $data));

        $account->setLocaleID($this->fetchLocalId($data));
        $account->setStatementDay($this->fetchStatementDay($data));
        $account->setLastBillingDate($this->fetchLastBillingDate($data));

        return $account;
    }

    /**
     * @param $data
     * @return mixed
     */
    protected function fetchLocalId($data)
    {
        $localId = $this->_getProperty(72, $data, false);
        if (empty($localId)) {
            $localId = $this->_getProperty(49, $data, false);
        }
        return $localId;
    }

    /**
     * @param $data
     * @return int|null
     */
    protected function fetchStatementDay($data)
    {
        $statementDay = $this->_getProperty(66, $data, false);
        if (empty($statementDay)) {
            $statementDay = $this->_getProperty(43, $data, false);
        }

        if (empty($statementDay)) {
            return null;
        }
        return (int)$statementDay;
    }

    /**
     * @param $data
     * @return int | null
     */
    protected function fetchLastBillingDate($data)
    {
        $lastBillingDate = $this->_getProperty(78, $data, false);
        if (empty($lastBillingDate)) {
            $lastBillingDate = $this->_getProperty(55, $data, false);
        }

        if (empty($lastBillingDate)) {
            return null;
        }

        return $lastBillingDate;
    }
}
