<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetDeliverLinesForPeriodByVendorList extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $list = array();
        $listData = $this->_getProperty(0, $responseArray);
        foreach ($listData as $lineData) {
            $list[] = $this->fetchDeliverLine($lineData);
        }
        return $list;
    }

    private function fetchDeliverLine($deliverLineData)
    {
        $deliverLine = new Service_PbaApi_Api_Response_Struct_DeliverLine();
        $deliverLine->setDeliverLineId($this->_getProperty(0, $deliverLineData));
        $deliverLine->setDetailId($this->_getProperty(1, $deliverLineData));
        $deliverLine->setResellerTransactionId($this->_getProperty(2, $deliverLineData));
        $deliverLine->setCustomerId($this->_getProperty(3, $deliverLineData));
        $deliverLine->setSubscriptionId($this->_getProperty(4, $deliverLineData));
        $deliverLine->setDetailTypeId($this->_getProperty(5, $deliverLineData));
        $deliverLine->setPlanId($this->_getProperty(6, $deliverLineData));
        $deliverLine->setResourceId($this->_getProperty(7, $deliverLineData));
        $deliverLine->setParentDeliverLineId($this->_getProperty(8, $deliverLineData));
        $deliverLine->setDeliverLineStatus($this->_getProperty(9, $deliverLineData));
        $deliverLine->setTaxAmount($this->_getProperty(10, $deliverLineData));
        $deliverLine->setTaxIncludedAmount($this->_getProperty(11, $deliverLineData));
        $deliverLine->setExtendedPrice($this->_getProperty(12, $deliverLineData));
        $deliverLine->setTaxAmountPerMonth($this->_getProperty(13, $deliverLineData));
        $deliverLine->setTaxIncludedAmountPerMonth($this->_getProperty(14, $deliverLineData));
        $deliverLine->setExtendedPricePerMonth($this->_getProperty(15, $deliverLineData));
        $deliverLine->setTaxPercent($this->_getProperty(16, $deliverLineData));
        $deliverLine->setDeliverLineStartDate($this->_getProperty(17, $deliverLineData));
        $deliverLine->setDeliverLineEndDate($this->_getProperty(18, $deliverLineData));
        $deliverLine->setDeliverLineBaseDate($this->_getProperty(19, $deliverLineData));
        $deliverLine->setPeriodInMonths($this->_getProperty(20, $deliverLineData));
        $deliverLine->setUnitMeasure($this->_getProperty(21, $deliverLineData));
        $deliverLine->setResourceAmount($this->_getProperty(22, $deliverLineData));
        $deliverLine->setDescription($this->_getProperty(23, $deliverLineData));
        $deliverLine->setSKU($this->_getProperty(24, $deliverLineData));
        $deliverLine->setDiscountPercent($this->_getProperty(25, $deliverLineData));
        $deliverLine->setUnitPrice($this->_getProperty(26, $deliverLineData));
        $deliverLine->setSalesId($this->_getProperty(27, $deliverLineData));
        $deliverLine->setBranchId($this->_getProperty(28, $deliverLineData));
        $deliverLine->setBillingPeriodType($this->_getProperty(29, $deliverLineData));
        $deliverLine->setBillingPeriod($this->_getProperty(30, $deliverLineData));
        $deliverLine->setParentDeliverLineId2($this->_getProperty(31, $deliverLineData));
        $deliverLine->setLowerBound($this->_getProperty(32, $deliverLineData));
        $deliverLine->setFromResourceId($this->_getProperty(22, $deliverLineData));
        return $deliverLine;
    }
}
