<?php
/**
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetPlanCategoryDetails extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result for operation PlanCategoryDetailsGet_API';

    /**
     * @param array $responseArray
     * @return Service_PbaApi_Api_Response_Struct_PlanCategoryDetails
     * @throws Service_PbaApi_Client_InvalidPropertyException
     */
    protected function _init(array $responseArray = NULL)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $categoryData = $this->_getProperty(0, $responseArray);

        $category = new Service_PbaApi_Api_Response_Struct_PlanCategoryDetails();
        $category->setPlanCategoryId($this->_getProperty(0, $categoryData));
        $category->setName($this->_getProperty(1, $categoryData));
        $category->setDescription($this->_getProperty(2, $categoryData));
        $category->setAccountId($this->_getProperty(3, $categoryData));

        return $category;
    }
}
