<?php
/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */

class Service_PbaApi_Api_Response_GetSubscriptionAvailablePlanList extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $listData = $this->_getProperty(0, $responseArray);

        $list = array();
        foreach ($listData as $itemData) {
            $item = new Service_PbaApi_Api_Response_Struct_SubscriptionAvailablePlanListItem();
            $item->setPlanId($this->_getProperty(0, $itemData));
            $item->setPlanName($this->_getProperty(1, $itemData));
            $list[] = $item;
        }
        return $list;
    }
}
