<?php

/**
 * @Copyright © 2002-2017 Acronis International GmbH. All rights reserved
 */
class Service_PbaApi_Api_Response_GetSubscriptionResourcesList extends Service_PbaApi_Client_Response
{
    const EXCEPTION_EMPTY_RESULT = 'Empty result';

    protected function _init(array $responseArray = null)
    {
        if (is_null($responseArray)) {
            throw new Service_PbaApi_Client_InvalidPropertyException(self::EXCEPTION_EMPTY_RESULT);
        }

        $subscriptionResourceList = $this->_getProperty(0, $responseArray);
        $subscriptionResourceListResponse = array();
        foreach ($subscriptionResourceList as $resource) {
            $resourceData = new Service_PbaApi_Api_Response_Struct_SubscriptionResourcesList();
            $resourceData->setResourceId($this->_getProperty(0, $resource));
            $resourceData->setResourceRateId($this->_getProperty(1, $resource));
            $resourceData->setResourceName($this->_getProperty(2, $resource));
            $resourceData->setStoreDescription($this->_getProperty(3, $resource));
            $resourceData->setStorePriceText($this->_getProperty(4, $resource));
            $resourceData->setStoreSortOrder($this->_getProperty(5, $resource));
            $resourceData->setStatus($this->_getProperty(6, $resource));
            $resourceData->setResourceCategory($this->_getProperty(7, $resource));
            $resourceData->setIncludedAmount($this->_getProperty(8, $resource));
            $resourceData->setAdditionalAmount($this->_getProperty(9, $resource));
            $resourceData->setUsedAmount($this->_getProperty(10, $resource));
            $resourceData->setOrderedAmount($this->_getProperty(11, $resource));
            $resourceData->setUnit($this->_getProperty(12, $resource));
            $resourceData->setMinUnits($this->_getProperty(13, $resource));
            $resourceData->setMaxUnits($this->_getProperty(14, $resource));
            $resourceData->setMeasurable($this->_getProperty(15, $resource));
            $resourceData->setRelativeStatus($this->_getProperty(16, $resource));
            $resourceData->setOrderNumber($this->_getProperty(17, $resource));
            $resourceData->setSetupFee($this->_getProperty(18, $resource));
            $resourceData->setRecurringFee($this->_getProperty(19, $resource));
            $resourceData->setOveruseFee($this->_getProperty(20, $resource));
            $resourceData->setLocation($this->_getProperty(21, $resource));
            $resourceData->setIsOveruseFeeTiered($this->_getProperty(22, $resource));
            $resourceData->setIsRecurringFeeTiered($this->_getProperty(23, $resource));
            $resourceData->setIsSetupFeeTiered($this->_getProperty(24, $resource, false));
            $subscriptionResourceListResponse[] = $resourceData;
        }
        return $subscriptionResourceListResponse;
    }
}
