<?php
/**
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\Services\Apsc;

use Acronis\App\Services\OssApi\OssApiAwareTrait;
use APS\Request;
use Service_OpenApi_ApiInterface as OssApiInterface;

trait ApscInstanceFactoryTrait
{
    use OssApiAwareTrait;

    /**
     * @return \APS\ControllerProxy
     * @throws \Exception
     */
    public function createApscInstance($apsInstanceId)
    {
        $token = $this->getOssApi()->getProviderToken();
        $controllerUri = $token[OssApiInterface::PROPERTY_CONTROLLER_URI];
        $_SERVER['HTTP_APS_CONTROLLER_URI'] = $controllerUri;
        $_SERVER['HTTP_APS_INSTANCE_ID'] = $apsInstanceId;
        $apsc = new \APS\ControllerProxy($controllerUri, null, null);

        // This call isn't separated from create instance method, because
        // we use only one APS instance at one time and it is necessary operation
        Request::setController($apsc);

        return $apsc;
    }
}