<?php
/**
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\Services\Apsc;

use Acronis\App\Services\FactoryInterface;
use Acronis\App\Services\OssApi\OssApiAwareTrait;
use Acronis\App\Services\Apsc\Exception\InappropriateFactoryUse;
use Str;
use Service_OpenApi_ApiInterface as OssApiInterface;

class ProviderApscFactory implements FactoryInterface
{
    use OssApiAwareTrait;

    const NAME = 'provider_apsc';

    private $providersToken;

    /**
     * @return \APS\ControllerProxy
     * @param string|null $apsInstanceId
     * @throws \Exception
     */
    public function createInstance()
    {
        if (php_sapi_name() === 'cli') {
            throw new InappropriateFactoryUse(Str::format(
                'Can\'t use "%s" for APS controller creation in CLI mode.',
                static::class
            ));
        }

        $ossApi = $this->getOssApi();
        $token = $ossApi->getProviderToken();

        return new \APS\ControllerProxy($token[OssApiInterface::PROPERTY_CONTROLLER_URI], null, $token[OssApiInterface::PROPERTY_APS_TOKEN]);
    }
}