<?php
/**
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\Services\Cache;

/**
 * Is designed very close to PSR-16 cache interface
 * https://www.php-fig.org/psr/psr-16/
 * Interface CacheInterface
 * @package Acronis\App\Services\Cache
 */
interface CacheInterface
{
    /**
     * @param string $key
     * @param null|int $ttl
     * @param mixed $value
     */
    public function set($key, $value, $ttl = null);

    /**
     * @param string $key
     * @param string|null $default
     * @return mixed
     */
    public function get($key, $default = null);

    /**
     * @param string $key
     * @param int $ttl
     */
    public function refresh($key, $ttl);

    /**
     * @param $key
     * @return boolean
     */
    public function has($key);
}