<?php
/**
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */

namespace Acronis\App\Services\Redis;

use Acronis\App\Services\Config\ConfigAwareTrait;
use Acronis\App\Services\Config\ConfigSchema;
use Acronis\App\Services\FactoryInterface;
use Arr;
use Predis\Client;

class PureRedisFactory implements FactoryInterface
{
    use ConfigAwareTrait;

    const NAME = 'pure_redis';

    public function createInstance()
    {
        return new Client($this->getRedisDsn());
    }

    /**
     * Returns "dsn" attribute of section "redis" in config, null if not present
     * @return null|string
     */
    private function getRedisDsn()
    {
        $config = $this->getConfig();
        $redisConfig = $config->getRedisConfig();

        return Arr::get($redisConfig, ConfigSchema::NODE_REDIS_DSN);
    }
}