#!/usr/bin/env php
<?php
/**
 * @Copyright © 2002-2018 Acronis International GmbH. All rights reserved
 */

$currentUser = posix_getpwuid(posix_getuid());
if ('root' === $currentUser['name']) {
    echo 'You launched the script with root privileges. Please run the script under "apache" user like:' . PHP_EOL;
    echo "sudo -H -u apache bash -c 'php $argv[0] help'" . PHP_EOL;
    exit(1);
}

require_once(__DIR__ . "/../app/bootstrap.php");

chdir(DIR_ROOT);
defined('APS_RUNTIME_HOME') || define('APS_RUNTIME_HOME', DIR_ROOT);
defined('APS_RUNTIME_NO_PROCESS') || define('APS_RUNTIME_NO_PROCESS', true);
defined('APS_DEVELOPMENT_MODE') || define('APS_DEVELOPMENT_MODE', true);

use Acronis\App\Console\Command\CloudSync;
use Acronis\App\Console\Command\DatabaseMigrate;
use Acronis\App\Console\Command\UsageReport\Erase;
use Acronis\App\Console\Command\UsageReport\FlushAll;
use Acronis\App\Console\Command\UsageReport\Master;
use Acronis\App\Console\Command\UsageReport\Process;
use Acronis\App\Console\Command\UsageReport\ViewList;
use Symfony\Component\Console\Application;

$application = new Application();
$application->add(new Master());
$application->add(new Process());
$application->add(new FlushAll());
$application->add(new Erase());
$application->add(new ViewList());
$application->add(new DatabaseMigrate());
$application->run();