# Acronis\Cloud\Client\RegistrationTokensApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteRegistrationTokensByTokenId**](RegistrationTokensApi.md#deleteRegistrationTokensByTokenId) | **DELETE** /registration_tokens/{token_id} | RegistrationTokensByTokenId
[**getRegistrationTokens**](RegistrationTokensApi.md#getRegistrationTokens) | **GET** /registration_tokens | RegistrationTokens
[**postRegistrationTokens**](RegistrationTokensApi.md#postRegistrationTokens) | **POST** /registration_tokens | RegistrationTokens


# **deleteRegistrationTokensByTokenId**
> deleteRegistrationTokensByTokenId($token_id)

RegistrationTokensByTokenId

Remove initial registration token

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\RegistrationTokensApi();
$token_id = "token_id_example"; // string | 

try {
    $api_instance->deleteRegistrationTokensByTokenId($token_id);
} catch (Exception $e) {
    echo 'Exception when calling RegistrationTokensApi->deleteRegistrationTokensByTokenId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_id** | **string**|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getRegistrationTokens**
> \Acronis\Cloud\Client\Model\RegistrationTokens\RegistrationTokensList getRegistrationTokens()

RegistrationTokens

List initial registration tokens

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\RegistrationTokensApi();

try {
    $result = $api_instance->getRegistrationTokens();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling RegistrationTokensApi->getRegistrationTokens: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**\Acronis\Cloud\Client\Model\RegistrationTokens\RegistrationTokensList**](../Model/RegistrationTokens/RegistrationTokensList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postRegistrationTokens**
> \Acronis\Cloud\Client\Model\RegistrationTokens\RegistrationToken postRegistrationTokens($body)

RegistrationTokens

Create initial registration token for tenant

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\RegistrationTokensApi();
$body = new \Acronis\Cloud\Client\Model\RegistrationTokens\RegistrationTokenPost(); // \Acronis\Cloud\Client\Model\RegistrationTokens\RegistrationTokenPost | 

try {
    $result = $api_instance->postRegistrationTokens($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling RegistrationTokensApi->postRegistrationTokens: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Acronis\Cloud\Client\Model\RegistrationTokens\RegistrationTokenPost**](../Model/RegistrationTokens/RegistrationTokenPost.md)|  |

### Return type

[**\Acronis\Cloud\Client\Model\RegistrationTokens\RegistrationToken**](../Model/RegistrationTokens/RegistrationToken.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

