# Acronis\Cloud\Client\TotpApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**postTotpSetup**](TotpApi.md#postTotpSetup) | **POST** /totp/setup | TotpSetup
[**postTotpVerify**](TotpApi.md#postTotpVerify) | **POST** /totp/verify | TotpVerify


# **postTotpSetup**
> \Acronis\Cloud\Client\Model\Totp\SetupResponse postTotpSetup($body)

TotpSetup

Initialize TOTP for logged in user and provide QR code

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\TotpApi();
$body = "body_example"; // string | 

try {
    $result = $api_instance->postTotpSetup($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling TotpApi->postTotpSetup: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | **string**|  |

### Return type

[**\Acronis\Cloud\Client\Model\Totp\SetupResponse**](../Model/Totp/SetupResponse.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postTotpVerify**
> \Acronis\Cloud\Client\Model\Totp\VerifyResponse postTotpVerify($body)

TotpVerify

Verify TOTP code

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\TotpApi();
$body = new \Acronis\Cloud\Client\Model\Totp\VerifyPost(); // \Acronis\Cloud\Client\Model\Totp\VerifyPost | 

try {
    $result = $api_instance->postTotpVerify($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling TotpApi->postTotpVerify: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Acronis\Cloud\Client\Model\Totp\VerifyPost**](../Model/Totp/VerifyPost.md)|  |

### Return type

[**\Acronis\Cloud\Client\Model\Totp\VerifyResponse**](../Model/Totp/VerifyResponse.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

