# Acronis\Cloud\Client\UsersApi

All URIs are relative to *https://localhost:443/api/2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**deleteUsersByUserId**](UsersApi.md#deleteUsersByUserId) | **DELETE** /users/{user_id} | UsersByUserId
[**deleteUsersReportSubscriptionsByUserId**](UsersApi.md#deleteUsersReportSubscriptionsByUserId) | **DELETE** /users/{user_id}/report-subscriptions/{report_id} | UsersReportSubscriptionsByUserId
[**deleteUsersTotpResetByUserId**](UsersApi.md#deleteUsersTotpResetByUserId) | **DELETE** /users/{user_id}/totp/reset | UsersTotpResetByUserId
[**deleteUsersTotpTrustedBrowsersByUserId**](UsersApi.md#deleteUsersTotpTrustedBrowsersByUserId) | **DELETE** /users/{user_id}/totp/trusted-browsers | UsersTotpTrustedBrowsersByUserId
[**getUsers**](UsersApi.md#getUsers) | **GET** /users | Users
[**getUsersAccessPoliciesByUserId**](UsersApi.md#getUsersAccessPoliciesByUserId) | **GET** /users/{user_id}/access_policies | UsersAccessPoliciesByUserId
[**getUsersByUserId**](UsersApi.md#getUsersByUserId) | **GET** /users/{user_id} | UsersByUserId
[**getUsersCheckLogin**](UsersApi.md#getUsersCheckLogin) | **GET** /users/check_login | UsersCheckLogin
[**getUsersLegalDocumentsByUserId**](UsersApi.md#getUsersLegalDocumentsByUserId) | **GET** /users/{user_id}/legal_documents | UsersLegalDocumentsByUserId
[**getUsersLoginInfoByUserId**](UsersApi.md#getUsersLoginInfoByUserId) | **GET** /users/{user_id}/login_info | UsersLoginInfoByUserId
[**getUsersMe**](UsersApi.md#getUsersMe) | **GET** /users/me | UsersMe
[**getUsersMeApplications**](UsersApi.md#getUsersMeApplications) | **GET** /users/me/applications | UsersMeApplications
[**getUsersReportSubscriptionsByUserId**](UsersApi.md#getUsersReportSubscriptionsByUserId) | **GET** /users/{user_id}/report-subscriptions | UsersReportSubscriptionsByUserId
[**postUsers**](UsersApi.md#postUsers) | **POST** /users | Users
[**postUsersEmailTestBrandingByUserId**](UsersApi.md#postUsersEmailTestBrandingByUserId) | **POST** /users/{user_id}/email/test_branding | UsersEmailTestBrandingByUserId
[**postUsersLegalDocumentsByUserId**](UsersApi.md#postUsersLegalDocumentsByUserId) | **POST** /users/{user_id}/legal_documents | UsersLegalDocumentsByUserId
[**postUsersPasswordByUserId**](UsersApi.md#postUsersPasswordByUserId) | **POST** /users/{user_id}/password | UsersPasswordByUserId
[**postUsersReportSubscriptionsByUserId**](UsersApi.md#postUsersReportSubscriptionsByUserId) | **POST** /users/{user_id}/report-subscriptions | UsersReportSubscriptionsByUserId
[**postUsersSendActivationEmailByUserId**](UsersApi.md#postUsersSendActivationEmailByUserId) | **POST** /users/{user_id}/send-activation-email | UsersSendActivationEmailByUserId
[**postUsersTotpTrustedBrowsersByUserId**](UsersApi.md#postUsersTotpTrustedBrowsersByUserId) | **POST** /users/{user_id}/totp/trusted-browsers | UsersTotpTrustedBrowsersByUserId
[**putUsersAccessPoliciesByUserId**](UsersApi.md#putUsersAccessPoliciesByUserId) | **PUT** /users/{user_id}/access_policies | UsersAccessPoliciesByUserId
[**putUsersByUserId**](UsersApi.md#putUsersByUserId) | **PUT** /users/{user_id} | UsersByUserId
[**putUsersMfaStatusByUserId**](UsersApi.md#putUsersMfaStatusByUserId) | **PUT** /users/{user_id}/mfa/status | UsersMfaStatusByUserId


# **deleteUsersByUserId**
> deleteUsersByUserId($user_id, $version)

UsersByUserId

Delete a user by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 
$version = "version_example"; // string | 

try {
    $api_instance->deleteUsersByUserId($user_id, $version);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->deleteUsersByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |
 **version** | **string**|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **deleteUsersReportSubscriptionsByUserId**
> deleteUsersReportSubscriptionsByUserId($user_id, $report_id)

UsersReportSubscriptionsByUserId

Delete user's subscription to the report.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 
$report_id = "report_id_example"; // string | 

try {
    $api_instance->deleteUsersReportSubscriptionsByUserId($user_id, $report_id);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->deleteUsersReportSubscriptionsByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |
 **report_id** | **string**|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **deleteUsersTotpResetByUserId**
> deleteUsersTotpResetByUserId($user_id, $body)

UsersTotpResetByUserId

Reset TOTP settings for user

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 
$body = "body_example"; // string | 

try {
    $api_instance->deleteUsersTotpResetByUserId($user_id, $body);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->deleteUsersTotpResetByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |
 **body** | **string**|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **deleteUsersTotpTrustedBrowsersByUserId**
> deleteUsersTotpTrustedBrowsersByUserId($user_id, $body)

UsersTotpTrustedBrowsersByUserId

Forget all trusted browsers for user

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 
$body = "body_example"; // string | 

try {
    $api_instance->deleteUsersTotpTrustedBrowsersByUserId($user_id, $body);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->deleteUsersTotpTrustedBrowsersByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |
 **body** | **string**|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getUsers**
> \Acronis\Cloud\Client\Model\Users\UserBatch getUsers($uuids, $external_ids, $tenant_id)

Users

Get users batch, used in Cloud version

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$uuids = "uuids_example"; // string | Return information for users with specified UUIDS
$external_ids = "external_ids_example"; // string | User IDs in external Identity Provider
$tenant_id = "tenant_id_example"; // string | Tenant UUID. Required when searching by external_id

try {
    $result = $api_instance->getUsers($uuids, $external_ids, $tenant_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->getUsers: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **uuids** | **string**| Return information for users with specified UUIDS | [optional]
 **external_ids** | **string**| User IDs in external Identity Provider | [optional]
 **tenant_id** | **string**| Tenant UUID. Required when searching by external_id | [optional]

### Return type

[**\Acronis\Cloud\Client\Model\Users\UserBatch**](../Model/Users/UserBatch.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getUsersAccessPoliciesByUserId**
> \Acronis\Cloud\Client\Model\AccessPolicies\AccessPoliciesList getUsersAccessPoliciesByUserId($user_id, $_issues, $include_user_group_policies, $if_modified_since)

UsersAccessPoliciesByUserId

List access policies.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 
$_issues = "_issues_example"; // string | 
$include_user_group_policies = "include_user_group_policies_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getUsersAccessPoliciesByUserId($user_id, $_issues, $include_user_group_policies, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->getUsersAccessPoliciesByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |
 **_issues** | **string**|  | [optional]
 **include_user_group_policies** | **string**|  | [optional]
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Acronis\Cloud\Client\Model\AccessPolicies\AccessPoliciesList**](../Model/AccessPolicies/AccessPoliciesList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getUsersByUserId**
> \Acronis\Cloud\Client\Model\Users\User getUsersByUserId($user_id, $_issues, $if_modified_since)

UsersByUserId

Get user by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 
$_issues = "_issues_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getUsersByUserId($user_id, $_issues, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->getUsersByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |
 **_issues** | **string**|  | [optional]
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Acronis\Cloud\Client\Model\Users\User**](../Model/Users/User.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getUsersCheckLogin**
> getUsersCheckLogin($username)

UsersCheckLogin

Check if login is available or already registered

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$username = "username_example"; // string | 

try {
    $api_instance->getUsersCheckLogin($username);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->getUsersCheckLogin: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **string**|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getUsersLegalDocumentsByUserId**
> \Acronis\Cloud\Client\Model\LegalDocument\UserLegalDocumentStatusList getUsersLegalDocumentsByUserId($user_id)

UsersLegalDocumentsByUserId

Display legal documents user is have to sign

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 

try {
    $result = $api_instance->getUsersLegalDocumentsByUserId($user_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->getUsersLegalDocumentsByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |

### Return type

[**\Acronis\Cloud\Client\Model\LegalDocument\UserLegalDocumentStatusList**](../Model/LegalDocument/UserLegalDocumentStatusList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getUsersLoginInfoByUserId**
> \Acronis\Cloud\Client\Model\Users\UserLoginInfo getUsersLoginInfoByUserId($user_id)

UsersLoginInfoByUserId

Get users login info by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 

try {
    $result = $api_instance->getUsersLoginInfoByUserId($user_id);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->getUsersLoginInfoByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |

### Return type

[**\Acronis\Cloud\Client\Model\Users\UserLoginInfo**](../Model/Users/UserLoginInfo.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getUsersMe**
> \Acronis\Cloud\Client\Model\Users\User getUsersMe($if_modified_since)

UsersMe

Get information about current authorized user. Used in Cloud version

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getUsersMe($if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->getUsersMe: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Acronis\Cloud\Client\Model\Users\User**](../Model/Users/User.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getUsersMeApplications**
> \Acronis\Cloud\Client\Model\Applications\ApplicationsList getUsersMeApplications($for_ui, $if_modified_since)

UsersMeApplications

Get information about applications available for user. Used in Cloud version

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$for_ui = "for_ui_example"; // string | Return applications list in form appropriate for UI, e.g. app switcher
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getUsersMeApplications($for_ui, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->getUsersMeApplications: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **for_ui** | **string**| Return applications list in form appropriate for UI, e.g. app switcher | [optional]
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Acronis\Cloud\Client\Model\Applications\ApplicationsList**](../Model/Applications/ApplicationsList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getUsersReportSubscriptionsByUserId**
> \Acronis\Cloud\Client\Model\Common\ModelList getUsersReportSubscriptionsByUserId($user_id, $if_modified_since)

UsersReportSubscriptionsByUserId

List all reports the user is subscribed to.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 
$if_modified_since = "if_modified_since_example"; // string | 

try {
    $result = $api_instance->getUsersReportSubscriptionsByUserId($user_id, $if_modified_since);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->getUsersReportSubscriptionsByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |
 **if_modified_since** | **string**|  | [optional]

### Return type

[**\Acronis\Cloud\Client\Model\Common\ModelList**](../Model/Common/ModelList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postUsers**
> \Acronis\Cloud\Client\Model\Users\User postUsers($body)

Users

Create a new user. Also, personal tenant will be created, if user created in Customer tenant and below. Can be retrieved by personal_tenant_id field from users GET request.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$body = new \Acronis\Cloud\Client\Model\Users\UserPost(); // \Acronis\Cloud\Client\Model\Users\UserPost | 

try {
    $result = $api_instance->postUsers($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->postUsers: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**\Acronis\Cloud\Client\Model\Users\UserPost**](../Model/Users/UserPost.md)|  |

### Return type

[**\Acronis\Cloud\Client\Model\Users\User**](../Model/Users/User.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postUsersEmailTestBrandingByUserId**
> postUsersEmailTestBrandingByUserId($user_id, $body)

UsersEmailTestBrandingByUserId

Send email to test branding and smtp settings

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 
$body = new \Acronis\Cloud\Client\Model\Users\TestBrandingPost(); // \Acronis\Cloud\Client\Model\Users\TestBrandingPost | 

try {
    $api_instance->postUsersEmailTestBrandingByUserId($user_id, $body);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->postUsersEmailTestBrandingByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |
 **body** | [**\Acronis\Cloud\Client\Model\Users\TestBrandingPost**](../Model/Users/TestBrandingPost.md)|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postUsersLegalDocumentsByUserId**
> postUsersLegalDocumentsByUserId($user_id, $body)

UsersLegalDocumentsByUserId

Sign listed legal documents

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 
$body = new \Acronis\Cloud\Client\Model\Common\ModelList(); // \Acronis\Cloud\Client\Model\Common\ModelList | 

try {
    $api_instance->postUsersLegalDocumentsByUserId($user_id, $body);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->postUsersLegalDocumentsByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |
 **body** | [**\Acronis\Cloud\Client\Model\Common\ModelList**](../Model/Common/ModelList.md)|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postUsersPasswordByUserId**
> postUsersPasswordByUserId($user_id, $body)

UsersPasswordByUserId

Set user's password. Method requires OAuth token authorization (password and session authentication is not supported), OAuth token must include authorization for user_admin role

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 
$body = new \Acronis\Cloud\Client\Model\Idp\PasswordPost(); // \Acronis\Cloud\Client\Model\Idp\PasswordPost | 

try {
    $api_instance->postUsersPasswordByUserId($user_id, $body);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->postUsersPasswordByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |
 **body** | [**\Acronis\Cloud\Client\Model\Idp\PasswordPost**](../Model/Idp/PasswordPost.md)|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postUsersReportSubscriptionsByUserId**
> \Acronis\Cloud\Client\Model\Reports\Report postUsersReportSubscriptionsByUserId($user_id, $body)

UsersReportSubscriptionsByUserId

Subscribe user to a report. Return report configuration

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 
$body = new \Acronis\Cloud\Client\Model\Reports\ReportSubscriptionPost(); // \Acronis\Cloud\Client\Model\Reports\ReportSubscriptionPost | 

try {
    $result = $api_instance->postUsersReportSubscriptionsByUserId($user_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->postUsersReportSubscriptionsByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |
 **body** | [**\Acronis\Cloud\Client\Model\Reports\ReportSubscriptionPost**](../Model/Reports/ReportSubscriptionPost.md)|  |

### Return type

[**\Acronis\Cloud\Client\Model\Reports\Report**](../Model/Reports/Report.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postUsersSendActivationEmailByUserId**
> postUsersSendActivationEmailByUserId($user_id, $body)

UsersSendActivationEmailByUserId

Send activation email to user

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 
$body = "body_example"; // string | 

try {
    $api_instance->postUsersSendActivationEmailByUserId($user_id, $body);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->postUsersSendActivationEmailByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |
 **body** | **string**|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **postUsersTotpTrustedBrowsersByUserId**
> postUsersTotpTrustedBrowsersByUserId($user_id, $body)

UsersTotpTrustedBrowsersByUserId

Remember browser as trusted

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 
$body = "body_example"; // string | 

try {
    $api_instance->postUsersTotpTrustedBrowsersByUserId($user_id, $body);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->postUsersTotpTrustedBrowsersByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |
 **body** | **string**|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putUsersAccessPoliciesByUserId**
> \Acronis\Cloud\Client\Model\AccessPolicies\AccessPoliciesList putUsersAccessPoliciesByUserId($user_id, $body)

UsersAccessPoliciesByUserId

Rewrite access policies for user

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 
$body = new \Acronis\Cloud\Client\Model\AccessPolicies\AccessPoliciesList(); // \Acronis\Cloud\Client\Model\AccessPolicies\AccessPoliciesList | 

try {
    $result = $api_instance->putUsersAccessPoliciesByUserId($user_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->putUsersAccessPoliciesByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |
 **body** | [**\Acronis\Cloud\Client\Model\AccessPolicies\AccessPoliciesList**](../Model/AccessPolicies/AccessPoliciesList.md)|  |

### Return type

[**\Acronis\Cloud\Client\Model\AccessPolicies\AccessPoliciesList**](../Model/AccessPolicies/AccessPoliciesList.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putUsersByUserId**
> \Acronis\Cloud\Client\Model\Users\User putUsersByUserId($user_id, $body)

UsersByUserId

Update a user by ID.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 
$body = new \Acronis\Cloud\Client\Model\Users\UserPut(); // \Acronis\Cloud\Client\Model\Users\UserPut | 

try {
    $result = $api_instance->putUsersByUserId($user_id, $body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->putUsersByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |
 **body** | [**\Acronis\Cloud\Client\Model\Users\UserPut**](../Model/Users/UserPut.md)|  |

### Return type

[**\Acronis\Cloud\Client\Model\Users\User**](../Model/Users/User.md)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **putUsersMfaStatusByUserId**
> putUsersMfaStatusByUserId($user_id, $body)

UsersMfaStatusByUserId

Enable/disable MFA for user

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure OAuth2 access token for authorization: auth
Acronis\Cloud\Client\Configuration::getDefaultConfiguration()->setAccessToken('YOUR_ACCESS_TOKEN');

$api_instance = new Acronis\Cloud\Client\Api\UsersApi();
$user_id = "user_id_example"; // string | 
$body = new \Acronis\Cloud\Client\Model\Users\MfaStatusPut(); // \Acronis\Cloud\Client\Model\Users\MfaStatusPut | 

try {
    $api_instance->putUsersMfaStatusByUserId($user_id, $body);
} catch (Exception $e) {
    echo 'Exception when calling UsersApi->putUsersMfaStatusByUserId: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **user_id** | **string**|  |
 **body** | [**\Acronis\Cloud\Client\Model\Users\MfaStatusPut**](../Model/Users/MfaStatusPut.md)|  |

### Return type

void (empty response body)

### Authorization

[auth](../../README.md#auth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

